/* @clake/react-bootstrap4-window v1.2.0 | by Clake
 * Copyright (c) 2025 Clake,
 * 2025-05-29T14:26:39+0800
 */
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

require("./css/CTableText.less");

var _reactBootstrap = require("@clake/react-bootstrap4");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CTableTextArea =
/*#__PURE__*/
function (_React$Component) {
  _inherits(CTableTextArea, _React$Component);

  function CTableTextArea(props) {
    var _this;

    _classCallCheck(this, CTableTextArea);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CTableTextArea).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "input", void 0);

    _defineProperty(_assertThisInitialized(_this), "changeHandler", function (val, row, obj) {
      _this.setState({
        value: val
      });

      if (typeof _this.props.onChange === 'function') {
        _this.props.onChange(obj, val);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "scrollHandler", function (e) {
      e.stopPropagation();
    });

    _this.state = {
      value: _this.parseValue(_this.props.data)
    };
    return _this;
  }

  _createClass(CTableTextArea, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // console.log('mount',this.input);
      this.input.input.addEventListener('wheel', this.scrollHandler, {
        passive: false
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.input.input.removeEventListener('wheel', this.scrollHandler);
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      this.setState({
        value: this.parseValue(nextProps.data)
      });
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps, nextState) {
      if (nextProps.disabled !== this.props.disabled) {
        return true;
      }

      return nextState.value !== this.state.value;
    }
  }, {
    key: "parseValue",
    value: function parseValue(val) {
      if (val === null || val === undefined) {
        return "";
      } else {
        return '' + val;
      }
    }
  }, {
    key: "getClasses",
    value: function getClasses() {
      var base = 'ck-ctable-text';
      return (0, _classnames["default"])(base, this.props.className);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this,
          _this$props$rows;

      return _react["default"].createElement("div", {
        className: this.getClasses()
      }, _react["default"].createElement(_reactBootstrap.TextArea, _extends({
        size: "sm",
        ref: function ref(c) {
          return _this2.input = c;
        }
      }, this.props, {
        onChange: this.changeHandler,
        data: this.state.value,
        rows: (_this$props$rows = this.props.rows) !== null && _this$props$rows !== void 0 ? _this$props$rows : 1
      })));
    }
  }]);

  return CTableTextArea;
}(_react["default"].Component);

var _default = exports["default"] = CTableTextArea;
//# sourceMappingURL=CTableTextArea.js.map
