import React from 'react';
import './css/CTableText.less';
import { ComponentProps, TextArea } from '@clake/react-bootstrap4';
interface Props extends ComponentProps {
    data?: any;
    align?: string;
    disabled?: boolean;
    onChange?: (evt: any, val: any, row?: any) => void;
    onSelect?: () => void;
    onFocus?: (e: any) => void;
    onBlur?: (e: any) => void;
    readOnly?: boolean;
    rows?: number;
}
interface State {
    value: string;
}
declare class CTableTextArea extends React.Component<Props, State> {
    input: TextArea;
    constructor(props: any);
    componentDidMount(): void;
    componentWillUnmount(): void;
    UNSAFE_componentWillReceiveProps(nextProps: Props): void;
    shouldComponentUpdate(nextProps: Props, nextState: State): boolean;
    parseValue(val: any): string;
    getClasses(): string;
    changeHandler: (val: any, row: any, obj: any) => void;
    scrollHandler: (e: WheelEvent) => void;
    render(): JSX.Element;
}
export default CTableTextArea;
//# sourceMappingURL=CTableTextArea.d.ts.map